      PROGRAM TRA2XTC

      IMPLICIT NONE

      INTEGER I,J,ID1,NAT,STEP,RET,MAXAT

      PARAMETER(MAXAT=20000)

      CHARACTER*80 XTCNAM,SDUM

      REAL*4 X(MAXAT*3),BOX(9),DT,TIME,PREC

      REAL XX(MAXAT*3),BOXX(9)

      LOGICAL GVFISF

      PREC=1000.0

      CALL GETARG(1,XTCNAM)
      CALL GETARG(2,SDUM)
      READ(SDUM,*) NAT

      IF (NAT.GT.MAXAT) THEN
         WRITE (0,*) '> NR OF ATOMS TOO LARGE FOR ARRAY BOUNDS'
         STOP
      ENDIF

      IF (GVFISF(XTCNAM)) THEN
         WRITE(0,*) XTCNAM,'already exists. Not overwritten'
         STOP
      ENDIF
      CALL XDRFOPEN(ID1,XTCNAM,"W",RET)
      IF (RET.EQ.0) THEN
         WRITE(0,*) '> ERROR OPENING XTC FILE:'
         WRITE(0,*) '> ',XTCNAM
         STOP
      ENDIF

      READ(5,*)
      DO I=1,1000000
         READ(5,100,END=50) (XX(J),J=1,NAT*3)
         DO J=1,NAT*3
            X(J)=XX(J)
         ENDDO
         READ(5,100,END=50) BOXX(1),BOXX(5),BOXX(9)
         DO J=1,9
            BOX(J)=BOXX(J)
         ENDDO
         CALL WRITEXTC(ID1,NAT,STEP,TIME,BOX,X,PREC,RET)
      ENDDO

 50   CONTINUE

 100  FORMAT(10F8.3)

      END
      LOGICAL FUNCTION GVFISF(FILNAM)
C///
C-------------------------------------------------------------------------------
C----                                                                       ----
C---- BECOMES TRUE IF THE FILE FILNAM EXISTS.                               ----
C----                                                                       ----
C---- THIS FUNCTION IS WRITTEN IN FORTRAN 77.                               ----
C----                                                                       ----
C-------------------------------------------------------------------------------
C\\\
      IMPLICIT          NONE
      CHARACTER*(*)  FILNAM
      INTEGER        GVFLEN
C-------
C------- TEST FOR EMPTY FILE NAME
C-------
         IF (GVFLEN(FILNAM).EQ.0) THEN
            GVFISF=.FALSE.
            RETURN
         END IF
C-------
C------- SEE IF THE FILE EXISTS
C-------
         INQUIRE (FILE=FILNAM,EXIST=GVFISF)

      RETURN
      END

      INTEGER FUNCTION GVFLEN(TEXT)
C///
C-------------------------------------------------------------------------------
C----                                                                       ----
C---- RETURNS THE LENGTH OF TEXT                                            ----
C---- THE LENGTH IS DEFINED AS THE SEQUENCE NUMBER IN TEXT OF THE LAST      ----
C---- NON-BLANK CHARACTER. UNDEFINED CHARACTERS ARE ASSUMED TO BE BLANK.    ----
C----                                                                       ----
C---- TEXT IS A CHARACTER STRING OF ANY LENGTH                              ----
C---- DO NOT FORGET TO DECLARE GVFLEN AS AN INTEGER IN THE CALLING ROUTINE  ----
C----                                                                       ----
C---- THIS ROUTINE IS WRITTEN IN FORTRAN 77.                                ----
C----                                                                       ----
C-------------------------------------------------------------------------------
C\\\
      IMPLICIT         NONE
      CHARACTER*(*)    TEXT
      INTEGER          I, ICH
C----
C---- INITIATE
C----
      GVFLEN=0
C----
C---- MEASURE THE LENGTH
C----
      DO 10 I=LEN(TEXT),1,-1
         ICH=ICHAR(TEXT(I:I))
         IF (ICH.NE.ICHAR(' ').AND.ICH.NE.0) THEN
            GVFLEN=I
            RETURN
         END IF
   10 CONTINUE

      RETURN
      END

